#!/usr/bin/env python
#   #----- MODIFY pseudo_code_dict BY -----------
#   #----- SUBSTITUTE FUNCTION IN TEXT FORM -----
#   #----- TO REAL pseudo_code ------------------
#   
#   ### THIS LINE IN THE TOP
#   from dttcmd import *
#
#   ### THESE LINES IN THE BOTTOM
#   self_func = []
#   for i in dir():
#       if callable(eval(i)): self_func.append(i)
#   
#   for i in pseudo_code_dict.keys():
#       p_list = pseudo_code_dict[i].sp_listit('\n')
#       for j in range(len(p_list)):
#           if '(' in p_list[j]:
#               if p_list[j].sp_listit('(',1)[0] in self_func:
#                   l = [n for n in range(len(p_list[j])) if p_list[j][n] == ')']
#                   t = p_list[j][:l[-1]+1]
#                   p_list[j] = p_list[j].rep_listace(t, eval(t))
#       pseudo_code_dict[i] = '\n'.join(p_list)
#   

import sys

from dttcmd import *

header_file = 'header_' + __name__[4:]
exec 'from %s import *' % (header_file,)

#func_arg_list = [[2, 0], [1, 0], [3, 1], [1, 1], [4, 0], [0, 1], [0, 1], [0, 1], [3, 0], [3, 0], [2, 0], [1, 0], [1, 0], [4, 0], [3, 0], [5, 0], [2, 0], [2, 0], [2, 0], [3, 0], [0, 0]]
#
#cvt_dict = {
#    'evheight_lu' : 0,   #  -422
#    'tvheight_lu' : 0,   #  -422
#    'vbase' : 1,   #  0
#    'tvheight_num' : 2,   #  908
#    'evheight' : 3,   #  1062
#    'tvheight' : 4,   #  1140
#    'ecvheight' : 5,   #  1450
#    'tvheight_po' : 5,   #  1450
#    'estemtc' : 6,   #  218
#    'ecstemt' : 6,   #  218
#    'tstemtc' : 6,   #  218
#    'cvt_7' : 7,   #  130
#    'cvt_8' : 8,   #  139
#    'estemt' : 9,   #  207
#    'tstemt' : 9,   #  207
#    'estemw' : 10,   #  240
#    'tstemw' : 11,   #  240
#    'ecstemw' : 12,   #  253
#    'cvt_13' : 13,   #  233
#    'ecstemtc': 13,  #230
#    'cvt_14' : 14,   #  242
#    'cvt_15' : 15,   #  214
#    'cvt_16' : 16,   #  188
#    'sarastemw' : 16,   #  188
#    'stemwa' : 16,   #  188
#    'cvt_17' : 17,   #  216
#    'cvt_18' : 18,   #  210
#    'cvt_19' : 19,   #  175
#    'cvt_20' : 20,   #  177
#    'sarastemt':20,
#    'cvt_21' : 21,   #  231
#    'cvt_22' : 22,   #  113
#    'head_sara_stem' : 22,   #  113
#    'cvt_23' : 23,   #  133
##USER LAND
#    'tvheight_num_shoot' : 24,  # 908+24=932
#    'evheight_shoot' : 25,      # 1062+24=1086
#    'tvheight_shoot' : 26,      # 1140+24=1164
#    'ecvheight_shoot' : 27,     # 1450+27=1477
#    'headstem'  : 28,    # 140
#    'headdia'   : 29,    # 430
#    'headstemplushole' : 30,    # 290 
#    'estemwc'   : 31,   # 260
#    'ecstemwc'   : 32,   # 273
#    'vbase_shoot': 33,  #24
#    'tvbase_shoot': 33,  #24
#    'head_sara':    34, #360
#    }


#---GENERATE STEM FUNCTION---
#predefine delta string of stem (put before gen_cvt_func)
#ds_headstemplushole = "15-4 16-4 17-2 18-6 19-2 20+2 21-2 24+4 28+4 29+4 30+4 32-4 33+4 34+4 38+8 "
ds_headstemplushole = "14+8 23+8 24+8 "
ds_headstem = "9-4 10-4 "
ds_hheaddia = ""
ds_vheaddia = ""
ds_head_sara_stem = "9-4 10-4 "
ds_head_sara = ""
ds_tstemtc = ""
#ds_tstemtc_thin = "9-2 10-2 11-2 12-2 13-2 14-2 15-2 16-2 "
ds_tstemt = ""
#ds_tstemt_thin = "9-2 10-2 11-2 12-2 13-2 14-2 15-2 16-2 "

gen_cvt_func_dict = {
    #FOR UNROUNDED STEM
    #[min,black]
    'mb':   ['estem*','tstem*','stem*','ecstem*'],
    #[min,rnd,black]
    'mrb':  ['headstem*','head_sara_stem','head_sara'],
    '0rg':  ['headdia'],
    #
#    #FOR ROUNDED STEM
#    #[min,rnd,black]
#    'mrb':  ['estem*','tstem*','stem*','ecstem*','headstem*','head_sara_stem','head_sara','sarastem*','wanstem*'],
#    #[rp0,rnd,grey]
#    '0rg':  ['headdia'],
    }

for arg,cvt_list in gen_cvt_func_dict.iteritems():
    new_list = []
    for i in cvt_list:
        if i[-1]=='*':
            c = i.strip('*')
            n = len(c)
            l = [x for x in cvt_dict.keys() if x[:n]==c]
            new_list.extend(l)
        else:
            new_list.append(i)
        
    for i in new_list:
        for j in ['1','1m','2','2m']:   #1=forward/bottomup, #2=reverse/topdown
            if j[-1] == 'm':    #m=move rp0
                cmd = 'mirp0'+arg
            else:
                cmd = 'mirp'+arg
            if j[0] == '1': #1=forward/bottomup, #2=reverse/topdown
                direction = '+'
            else:
                direction = '-'
            #AUTO GENERATE delta string
            try:
                exec "a = ds_%s " % (i,)
            except:
                exec "ds_%s = ''" % (i,)

            #GEN FUNC
            exec '''def %s_%s(s,direction="%s"):
    return %s("%s",s,ds_%s,direction)
''' % (i,j,direction,cmd,i,i,)

            #GEN EXTRA FUNC FOR THIN OF estemt, tstemt
            #USE IN UPPER STEM OF kho_khai, kho_kwai
            #***PREDEFINE: ds_estemt_thin
            if i in ['estemt','estemtc','tstemt','tstemtc']:
                #AUTO GENERATE delta string
                try:
                    exec "a = ds_%s_thin " % (i,)
                except:
                    #DEFAULT VALUE FOR 14,15,16 ppem
                    exec "ds_%s_thin = '14-2 15-2 16-2 '" % (i,)
                #GEN FUNC
                exec '''def %s_thin_%s(s,direction="%s"):
    return %s("%s",s,ds_%s_thin,direction)
''' % (i,j,direction,cmd,i,i,)


#EXAMPLE OF CVT FUNCTION DEFINED:
#
#def estemw_1(s): return """
#   MIRP[rnd,black]    estemw s
#   f_dstr(s,"ds_estemw")
#   """
#
#def estemw_2(s): return """
#   MIRP[rnd,black]    estemw s
#   f_dstr(s,"ds_estemw",direction="-")
#   """


#----------------------------------------
#DRY HEAD: KEEP HEAD OF CHARACTERS DRIED FOR 14,15,16 ppem
#ENABLE DRY HEAD FOR BOOK
#ds_dryhead = "11+2 12+2 13+2 14+3 15+3 16+3 "
ds_dryhead = "11+1 12+1 13+1 14+1 15+2 16+2 "
def dh1(*l): #dry head 
    d = {}
    for s in l:
        if s-1 < 0 or s+1 < 0:
            raise ValueError("ds value < 0: dh1(%s)" % (l,))
        d[s-1] = ds_dryhead
        d[s+1] = swap_dstr(ds_dryhead)
    return f_dstr_dict(d)
#    return f_dstr_dict({
#        s-1: "15+4 16+3 17+3 18+3 ",
#        s+1: "15-4 16-3 17-3 18-3 " })

def dh2(*l): #dry head
    d = {}
    for s in l:
        if s-1 < 0 or s+1 < 0:
            raise ValueError("ds value < 0: dh2(%s)" % (l,))
        d[s-1] = swap_dstr(ds_dryhead)
        d[s+1] = ds_dryhead
    return f_dstr_dict(d)
#    return f_dstr_dict({
#        s-1: "15-4 16-3 17-3 18-3 ",
#        s+1: "15+4 16+3 17+3 18+3 " })

def dh11(s): #dry 1 point +
    return f_dstr(s,ds_dryhead)

def dh12(s): #dry 1 point -
    return f_dstr(s,ds_dryhead,direction='-')

#DISABLE DRY HEAD FOR BOLD
#def dh1(*l):
#    return ""
#def dh2(*l):
#    return ""
#def dh11(s):
#    return ""
#def dh12(s):
#    return ""


ds_ud = "11+1 12+2 13+2 14+3 15+3 16+3 "
def ud1(s): #universal dry +
    return f_dstr(s,ds_ud)

def ud2(s): #universal dry -
    return f_dstr(s,ds_ud,direction='-')

ds_udx = "11+2 12+3 13+4 14+4 15+4 16+4 17+6 18+4 "
def udx1(s): #universal dry +
    return f_dstr(s,ds_udx)

def udx2(s): #universal dry -
    return f_dstr(s,ds_udx,direction='-')


#================================================
def evbc1(s,li=[]):
    return pl(""
        , mirp0rg("evbase_shoot",s)
        , f_ip(li)
        )

def tvbc(s,li=[]):  #thai vbase curve
    return pl(""
        , mirp0rg("tvbase_shoot",s)
        , f_ip(li)
        )

def tvblu(s,li=[]):
    return pl(""
        , mirprg("tvheight_lu",s)
        , f_ip(li)
        )

def tvblum(s,li=[]):
    return pl(""
        , mirp0rg("tvheight_lu",s)
        , f_ip(li)
        )

def tvtc2(s,li=[]): #thai vtop curve
    return pl(""
        , mirp0rg("tvheight_shoot",s,"")
        , f_ip(li)
        )

def tvt2(s,li=[]):
    return pl(""
        #, 'SROUND 74', mirprg("tvheight",s), 'RTG'
        , 'SROUND 74', mirprg("tvheight",s,"15-8 24+8 "), 'RTG'
        , f_ip(li)
        )

def tvt2m(s,li=[]):
    return pl(""
        , mirp0rg("vheight",s,ds_vheight)
        , f_ip(li)
        )

def tvtpo(s,li=[]):
    return pl(""
        , mirprg("tvheight_po",s)
        , f_ip(li)
        )

def tvtpom(s,li=[]):
    return pl(""
        , mirp0rg("tvheight_po",s)
        , f_ip(li)
        )

def thbsara(s):
    return mdapr(s)

def tvtsara(s):
    return mdapr(s,"")

def tvtwanayuk(s):
    #return mdapr(s,"14-8 15-8 16+8 17+8 18+8 ")
    return mdapr(s,"")


def tvtn(s, li=[]):
    return pl(""
        , 'SROUND 73', mirp0rg("tvheight_num",s,"21+8 "), 'RTG'
        , f_ip(li)
        )

def tvtnc(s, li=[]):
    return pl(""
        , mirp0rg("tvheight_num_shoot",s)
        , f_ip(li)
        )
#==================================================

def head_0(s,li,direction="+",dia="hheaddia", dsh_extra=""):
    #round head
    s,add1 = gen_alignrp(s)
    i1,addi1 = gen_alignrp(li[0],2)
    i2,addi2 = gen_alignrp(li[1],2)
    l = li[2:]
    reverse_dir = direction.replace('+','*').replace('-','+').replace('*','-')
    if dia == "head_sara":
        ds_dia = ds_head_sara
        stem = "head_sara_stem"
        ds_stem = ds_head_sara_stem
    else:
        #ds_dia = ds_headdia
        if dia == 'hheaddia':
            ds_dia = ds_hheaddia
        else:
            ds_dia = ds_vheaddia
        stem = "headstem"
        ds_stem = ds_headstem
    if l:
        addip = f_ip(l)
    else:
        addip = ""
    if dsh_extra:
        add1_extra = f_dstr(s,dsh_extra)
    else:
        add1_extra = ""
    return pl(""
        , 'SROUND 3'
        , mirpmrb(stem,i1,ds_stem,direction)
        , addi1
#        , 'SROUND 69'
, 'SROUND 73'
        , mirp0rg(dia,s,ds_dia,direction)
        , add1_extra
        , add1
        , addip
        , 'SROUND 3'
        , mirpmrb(stem,i2,ds_stem,reverse_dir)
        , addi2
        , 'RTG'
        )

def hhead1(s,li,dsh_extra=""):
    #left to right
    return head_0(s,li,direction="+",dsh_extra=dsh_extra)

def hhead2(s,li,dsh_extra=""):
    #right to left
    li = [li[1],li[0]] + li[2:]
    return head_0(s,li,direction="-",dsh_extra=dsh_extra)

def vhead1(s,li,dsh_extra=""):
    #up
    return head_0(s,li,direction="+",dia="vheaddia",dsh_extra=dsh_extra)

def vhead2(s,li,dsh_extra=""):
    #down
    li = [li[1],li[0]] + li[2:]
    return head_0(s,li,direction="-",dia="vheaddia",dsh_extra=dsh_extra)

def headsara1(s,li,dsh_extra=""):
    return head_0(s,li,direction="+",dia="head_sara",dsh_extra=dsh_extra)

def headsara2(s,li,dsh_extra=""):
    li = [li[1],li[0]] + li[2:]
    return head_0(s,li,direction="-",dia="head_sara",dsh_extra=dsh_extra)



def xhead0(s2,s3,direction="+"):
    s2,add2 = gen_alignrp(s2,2)
    s3,add3 = gen_alignrp(s3,2)
    return pl(""
        , 'SROUND 3'
        , headstem_1(s2,direction=direction)
        , add2
        , 'RTG'
        , headstemplushole_1(s3,direction=direction)
        , add3
        , 'RTG'
        )


def xhead1(s1,s2,s3,dstr="14-8 ",direction="+"):
    s1,add1 = gen_alignrp(s1)
    return pl(""
        , 'SROUND 71'
        , mdrp0mrg(s1,dstr)
        , 'RTG'
        , add1
        , xhead0(s2,s3,direction)
        )

def xhead2(s1,s2,s3,dstr="",direction="-"):
    s1,add1 = gen_alignrp(s1)
    return pl(""
#        , 'SROUND 72'
        , mdrp0rg(s1,dstr)
#        , 'RTG'
        , add1
        , xhead0(s2,s3,direction)
        )


#================================================
def v_notch_ko_kai(s1,s1s,s2):
    return pl(""
        , mdrp0rg(s1,"23+8 ")
        , alignrp(s1s)
        , stem_notch_1(s2)
        , dx(s2,-8)
        )

def v_head_kho_khai(s1,li1, s2, s3,s4, li4, add1=""):
    return pl(""
        , tvtc2(s1,li1)
        , add1
        #, 'RTDG',tstemt_thin_2(s2),'RTG'
        , tstemt_thin_2(s2)
        , mdrp0rg(s3,"")
        , vhead2(s4,li4)
        )

def v_head_kho_khuat(s1,s1s,li1, s2,s2s, s3,s4, s5,s6,li6 , add1=""):
    return pl(""
        , tvtc2(s1, li1)
        , alignrp(s1s)
        , add1
        , tstemt_2(s2)
        , shprp2(s2s)
        , 'RTDG',mdrp0mrg(s3),'RTG'
        , mdrpb(s4)
        , srp0(s1)
        , mdrp0rg(s5)
        , vhead2(s6,li6)
        )

def v_top_kho_khwai(s1,li1,s2, s3,s4,li4,add1="",do_dek=False):
    if len(li4) > 3 and not do_dek:
        add4 = f_dstr_dict({
#            li4[2]:"14+2 15+2 16+2 ",
            li4[2]:"14-4 15-4 16-4 ",
            })
    else:
        add4 = ""
    if do_dek:
        top_stem = tstemtc_thin_2(s2)
        ds3 = "9-8 10-8 "
    else:
        top_stem = tstemt_thin_2(s2)
        ds3 = "9-8 "

    return pl(""
        , tvtc2(s1,li1)
        , add1
        , top_stem
#        , 'RUTG'
        , mdrp0rw(s3,ds3)
#        , 'RTG'
        , vhead2(s4,li4)
        , add4
        )

def v_top_kho_khon(s1,s1s,li1, s2,s2s, s3,s4, s5,s6,li6):
    if len(li6) > 3:
        add6 = f_dstr_dict({
            li6[2]:"14+2 15+2 16+2 ",
            li6[3]:"14-4 15-4 16-4 ",
            })
    else:
        add6 = ""
    return pl(""
        , tvtc2(s1,li1)
        , alignrp(s1s)
        , tstemtc_2(s2)
        , shprp2(s2s)
        , 'RUTG'
        , mdrp0rg(s3)
        , 'RTG'
        , tstemtc_2(s4)
        , mdrp0mrw(s5)
        , mdapr(s5)
        , vhead2(s6,li6)
        , add6
        )
        
def v_top_ro_rua(s1,li1, s2, s3,s4,s5):
    return pl(""
        , tvtc2(s1,li1)
#        , tstemtc_thin_2m(s2)
        , mdrp0mrb(s2)
        , mdrp0g(s3)
        , tstemtc_1(s4)
        , srp0(s1)
        , mdrp0g(s5)
        )

def h_sara_i(r1,r2,r3,r4):
    return pl(""
        , thbsara(r2)
        , mdrpmb(r1)
        , mdrp0rg(r4)
        , tstemw_1(r3)
        )

def v_sara_i(s1,s2,s3,s4,s5,s6):
    return pl(""
        , tvtsara(s1)
        , mdrpmb(s2)
        , mdrp0rw(s3)
        , mdrpmb(s4)
        , mdrp0mrw(s5)
        , mdrp0mb(s6)
        , iy()
        )

#================================================
#new point reference
#f0,r0,...: use tuple to align multiple points

def trs_no_nu(r1,r2, h1,h2,li, r0, dsr="",dsh=""):
    #thai rear stem of no nu
    return pl(""
        , mdapr(r0)
        , mdrp0mrw(h2,dsr)
        , tstemt_2(li[1])
        , mdrp0rg(h1,dsh)
        , alignrp(r1)
        , tstemw_1(li[0])
        , shprp2(r2)
        )

def trs_e(f1,f2, r1,r2,r3, r0):
    #sara e
    return pl(""
        , mdapr(r0)
        , mdrp0mrw(r1)
        , xhead0(r2,r3,direction="-")
        , mdrp0rg(f1)
        , tstemw_1(f2)
        )

#================================================
def tx2_0(f0, f1,f2, r1,r2, r0, fstem=tstemw_1,rstem=tstemw_1m,fround=70,rround=74,dsf="",dsr=""):
    #thai x-direction walk for 2 stem: ko_kai,
    return uxus2(f0, f1,fstem,f2, r1,rstem,r2, r0, fround=fround, rround=rround,dsf=dsf,dsr=dsr)

def tx2_0k(f0, f1,f2, r1,r2, r0, lifr=[], fstem=tstemtc_1,rstem=tstemw_1,fround=70,rround=74,dsf="",dsr=""):
    return pl(""
        , tx2_0(f0, f1,f2, r1,r2, r0, fstem=fstem,rstem=rstem,fround=fround,rround=rround,dsf=dsf,dsr=dsr)
        , add_ip(f1,r2,lifr)
        )

def tx2_1(f0, f1,f2,f3, f4,f5, r1,r2, r0, dsf="11-8 "):
    #thai x-direction walk for 2 stem: tho_thahan,
    fx4,temp = gen_alignrp(f4)
    return pl(""
        , tx2_0(f0, f4,f5, r1,r2, r0, fround=72, dsf=dsf)
#        , srp0(fx4)
        , xhead1(f1,f2,f3)
        )

def tx2_2(f0, f1,f2, f3,f4,f5, r1,r2, r0, fround=70, dsf=""):
    #thai x-direction walk for 2 stem: pho_phung
#    fx1,temp = gen_alignrp(f1)
    return pl(""
        , tx2_0(f0, f1,f2, r1,r2, r0, fround=fround, dsf=dsf)
#        , srp0(fx1)
        , xhead2(f3,f4,f5)
        )

def tx2_3(f0, f1,f2,li12, f3,f4, f5,f6, r1,r2, r0, dsh_extra="",i56=-1):
    #kho_khai
    fx0,temp = gen_alignrp(f0)
    f1,addf1 = gen_alignrp(f1)
    fx3,temp = gen_alignrp(f3)
    f5,addf5 = gen_alignrp(f5)
    f6,addf6 = gen_alignrp(f6,2)
    rx1,temp = gen_alignrp(r1)
    if i56 >= 0:
        addi56 = f_ip([i56])
    else:
        addi56 = ""
    return pl(""
        , tx2_0(f0, f3,f4, r1,r2, r0, fround=72)
        , ip_round(fx0,fx3, f1)
        , addf1
        , hhead1(f2,li12,dsh_extra=dsh_extra)
        , ip_round(fx3,rx1,f5)
        , addf5
        , mdrpmb(f6)
        , addi56
        , addf6
        )


def tx1(f0, r1,r2, r0, rstem=tstemw_1,rround=74):
    #thai x-direction walk for 1 stem
    return uxus1(f0, r1,rstem,r2, r0, rround=rround)

def tx1_0(f0, f1, r1,r2, r0, rstem=tstemw_1, rround=74):
    #thai x-direction walk for 1 stem: ngo_ngu
    fx0,temp = gen_alignrp(f0)
    f1,addf1 = gen_alignrp(f1)
    rx1,temp = gen_alignrp(r1)
    return pl(""
        , tx1(f0, r1,r2, r0, rstem=rstem, rround=rround)
        , ip_round(fx0,rx1, f1)
        )

#def tx1_1(f0, f1,f2, r1, r0, fstem='tstemw', fround=72, rround=70):
#    return uxrs1f(f0,f1,fstem,f2,r1,r0,fround,rround)
#
#
#
def tx3_0(f0, f1,f2, m1,m2, r1,r2, r0, fstem=tstemw_1,mstem=tstemw_1,rstem=tstemw_1m,dsf="",dsm="",dsr=""):
    #thai x-direction walk for 3 stem: cho_choe
    return uxus3(f0, f1,fstem,f2, m1,mstem,m2, r1,rstem,r2, r0, dsf=dsf, dsm=dsm, dsr=dsr)

#================================================
def th_ko_kai(s0, s1,s2,s3, s4,s5,s6):
    return pl(""
        , add_ip(s0,s1,[s2])
        , srp0(s2)
        , mdrpb(s3)
        , srp0(s4)
        , mdrp0g(s5)
        , mdrpb(s6)
        )

def th_kho_khwai(s1, s2,s3,i23, s4,li4, ds=""):
    return pl(""
        , srp0(s1)
        , mdrp0rg(s2)
        , tstemw_1(s3)
        , f_ip([i23])
        , mdrp0rg(s4,ds)
        , xhead0(li4[1],li4[0],direction="-")
        )

def th_do_dek(s1, s2,s3,i23, s4,s5,li45, ds=""):
    return pl(""
        , srp0(s1)
        , mdrp0rg(s2)
        , tstemw_1(s3)
        , f_ip([i23])
        , mdrp0mrg(s4,ds)
        , xhead0(li45[0],li45[1])
        , f_ip(li45[2:])
        , srp0(li45[1])
        , mdrpmb(s5)
        )

#================================================
pseudo_code_dict = {

    'uni0E01':      #KO KAI
        packline(""
        , tx2_0(26, 14,12, 1,25, 27)
        , th_ko_kai(26, 14,19,8, 12,10,17)
        , add_ip(19,25,[5,22])
        , ix()
        #y
        , sy()
        , mdap(1)
        , alignrp(13)
        , tvtc2(22,[15,17,19, 8,10,12, 2,25])
        , tstemt_2(5)
        , iy()
        ),

    'uni0E02':    #KHO KHAI
        packline(""
        , tx2_3(55, 23,17,[52,46,14], 3,34, 9,29, 38,40, 56)
        , ud2(14)
        , ix()
        , dh2(20)
        , dh12(15)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(2)
        , shprp2(35)
        , tvt2(40)
        , v_head_kho_khai(26,[4,34,9,29], 12, 14,20,[43,49])
        , iy()
        , dh1(23,9)
        , dh2(17,29)
        ),

    'uni0E03':    #KHO KHUAT
        packline(""
        , tx2_3(64, 28,22,[61,55,19], 3,43, 9,38, 47,49, 65, dsh_extra="")
        , add_ip(28,38, [31,17,33,35,11])
        , srp0(33)
        , mdrpb(14)
        , mdrpb(13)
        , ix()
        , dh12(20)
        , dh2(25)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(2)
        , shprp2(44)
        , tvt2(49)
        , v_head_kho_khuat(35,31,[4,43,9,38], 11,17,13,33, 19,25,[52,58])
        , iy()
        , dh1(9,28)
        , dh2(22,38)
        ),

    'uni0E04':    #KHO KHWAI
        packline(""
        , tx2_0k(57, 38,8, 1,44, 58, [41,5])
        , th_kho_khwai(38, 33,28,11, 16,[54,48])
        , ix()
        , dh1(13)
        , dh2(19)
        #y
        , sy()
        , mdap(1)
        , alignrp(30)
        , v_top_kho_khwai(41,[38,8,11,2,41],5, 13,19,[45,51,21])
        , ud2(11)
        , iy()
        , dh2(16)
        ),

    'uni0E05':    #KHO KHON
        packline(""
        , tx2_0k(66, 43,13, 1,53, 67, [46,10,48,50,5])
        , th_kho_khwai(43, 38,33,16, 21,[63,57])
        , srp0(48)
        , mdrpb(8)
        , mdrpb(7)
        , ix()
        , dh1(18)
        , dh2(24)
        #y
        , sy()
        , mdap(1)
        , alignrp(35)
        , v_top_kho_khon(50,46,[43,13,16,2,53], 5,10, 7,48, 18,24,[54,60,26])
        , ud2(16)
        , iy()
        , dh2(21)
        ),

    'uni0E06':    #KHO RAKHANG
        packline(""
        , tx2_3(80, 39,33,[70,64,30], (13,74),(54,4), 19,49, (58,1),60, 81, dsh_extra="")
        , add_ip(39,49,[42,28,44,26,25,46,22])
        , srp0(13)
        , mdrp0rg(10)
        , mdrpmb(78)
        , ix()
        , dh12(31)
        , dh2(36,7)
        #y
        , sy()
        , mdap(1)
        , mdrpmb(58)
        , tvt2(60)
        , v_head_kho_khuat(46,42,[19,49,14,54], 22,28, 25,44, 30,36,[61,67])
        , srp0(1)
        , tvbc(7)
        , tstemtc_1(72)
        , mdrp0rg(13)
        , alignrp(55)
        , tstemt_2(75)
        , shprp2(4)
        , iy()
        , dh2(33)
        , dh1(9,39)
        ),

    'uni0E07':    #NGO NGU
        packline(""
        , tx2_0(30, 2,3, (4,1),17, 31, fstem='b')
        , srp0(4)
        , xhead1(11,27,21)
        , ix()
        , dh1(14)
        , dh2(8)
        #y
        , sy()
        , mdapr(1)
        , mdrpmb(4)
        , tvtc2(14,[3])
        , vhead2(8,[18,24])
        , mdapr(3)
        , iy()
        , dh1(11)
        ),

    'uni0E08':    #CHO CHAN
        packline(""
        , tx2_0(43, 25,24, (18,1),30, 44, fstem='b')
        , ip_round(43,1,12)
        , srp0(12)
        , hhead1(6,[40,34,4])
        , add_ip(25,30,[27,22])
        , ix()
        , dh1(15)
        , dh2(9)
        #y
        , sy()
        , mdap(1)
        , tvtc2(27,[18,24,19,30])
        , tstemtc_2(22)
        , mdapr(24)
        , mdrp0mrw(15)
        , vhead2(9,[31,37])
        , iy()
        , dh1(12)
        , dh2(6)
        ),

    'uni0E09':    #CHO CHING
        packline(""
        , trs_no_nu(16,28, 35,31,[55,52], 58)
        , uxus_go_front_stem(57, 1,tstemw_1,(13,0), 28, dsf="10-8 ")
        , xhead1(7,47,41)
        , ip_round(58,1,23)
        , mdrpg(22)
        , add_ip(23,28,[25,20])
        , ix()
        , dh1(10)
        , dh2(4,33)
        #y
        , sy()
        , mdap(0)
        , mdrpmb(14)
        , tvtc2(25,[17,28,22])
        , tstemt_2(20)
        , mdapr(22)
        , mdrp0mrw(10)
        , vhead2(4,[38,44])
        , srp0(0)
        , tvbc(33)
        , tstemtc_1(50)
        , mdrp0rg(16)
        , alignrp(29)
        , tstemt_2(36)
        , shprp2(54)
        , iy()
        , dh1(7)
        , dh2(31)
        ),

    'uni0E0A':    #CHO CHANG
        packline(""
        , tx2_3(67, 22,16,[64,58,13], 3,53, 9,27, (44,30),(39,32), 68,i56=48)
        , srp0(27)
        , mdrpg(36)
        , ud2(13)
        , ud2(36)
        , ix()
        , dh12(14)
        , dh2(19)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(2)
        , shprp2(54)
        , v_head_kho_khai(25,[4,53,9,27,48,36,45,39], 11, 13,19,[55,61],
            add1=mdrpmrg(32))
        , iy()
        , dh2(16)
        , dh1(22,9)
        ),

    'uni0E0B':    #SO SO
        packline(""
        , tx2_3(79, 28,22,[76,70,19], 3,65, 9,38, (56,42),(51,44), 80, i56=60, dsh_extra="")
        , add_ip(28,38, [31,17,35,11,33])
        , srp0(33)
        , mdrpb(14)
        , mdrpb(13)
        , srp0(38)
        , mdrpb(48)
        , ud2(48)
        , ix()
        , dh12(20)
        , dh2(25)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(2)
        , shprp2(66)
        , v_head_kho_khuat(35,31,[4,65,9,38,48,60,57,51], 11,17, 13,33, 19,25,[67,73],
            add1=mdrpmrg(44))
        , iy()
        , dh2(22)
        , dh1(28,9)
        ),

    'uni0E0C':    #CHO_CHOE
        packline(""
        , tx3_0(70, 34,23, (12,53),(45,4), (48,1),50, 71)
        , srp0(34)
        , xhead2(29,61,67)
        , ip_round(29,12,10)
        , srp0(10)
        , tstemt_1(56)
        , th_ko_kai(70, 34, 39,19, 23,21,37)
        #
        , add_ip(39,45,[42,16])
        , ix()
        , dh1(26)
        , dh2(31,7)
        #y
        , sy()
        , mdap(1)
        , mdrpmb(48)
        , tvt2(50)
        , tvtc2(42,[35,37,39,19,21,23,13,45])
        , tstemtc_2(16)
        , srp0(1)
        , tvbc(31)
        , alignrp(7)
        , vhead1(26,[58,64])
        , srp0(7)
        , tstemtc_1(51)
        , mdrp0rg(12)
        , alignrp(46)
        , tstemt_2(54)
        , shprp2(4)
        , iy()
        , dh1(10)
        , dh2(29)
        ),

    'uni0E0D.descless':    #YO YING
        packline(""
        , tx3_0(55, 23,12, 1,34, 38,40, 56)
        , srp0(23)
        , xhead2(18,46,52)
        , th_ko_kai(55, 23,28,8, 12,10,26)
        #
        , add_ip(28,34,[31,5])
        , ix()
        , dh1(15)
        , dh2(20)
        #y
        , sy()
        , mdap(1)
        , tstemt_1(35)
        , tvt2(40)
        , tvtc2(31,[24,26,28, 8,10,12, 2,34])
        , tstemtc_2(5)
        , srp0(1)
        , tvbc(20)
        , vhead1(15,[43,49])
        , iy()
        , dh2(18)
        ),

    'desc.uni0E0D':
        packline(""
        , thbsara(20)
        , mdrpmb(21)
        , mdrp0mrw(9)
        , mdrprg(3)
        , f_ip([32,26])
        , ix()
        #y
        , sy()
        , mdap(35)
        , mdrp0mrw(6)
        , mdrprg(21)
        , mdrp0rg(12)
        , f_ip([23,29])
        , mdrp0rg(0)
        , mdrpmb(15)
        , iy()
        ),

    'uni0E0E':    #DO CHADA
        packline(""
        , tx2_1(77, 38,74,68, 43,31, (20,1),54, 78)
        , th_ko_kai(77, 43,48,27, 31,29,46)
        , srp0(1)
        , mdrprg(57)
        , f_ip([13,18,3])
        , mdrp0rg(8)
        , mdrpmb(62)
        , add_ip(48,54,[51,24])
        , dx(57,8)
        , dx(18,-8)
        , ix()
        , dh1(41,11)
        , dh2(35,5)
        #y
        , sy()
        , mdap(77)
        , tvtc2(51,[44,46,48,27,29,31, 21,54])
        , tstemtc_2(24)
        , srp0(77)
        , tvbc(35)
        , vhead1(41,[65,71])
        , srp0(77)
        , tvblum(5)
        , alignrp(1)
        , vhead1(11,[55,59, 13,18,57,3,20])
#
        , dx(3,8)
        , dx(13,-8)
        , iy()
        , dh1(38,8)
        ),

    'uni0E0F':    #TO PATAK
        packline(""
        , tx2_1(82, 43,79,73, 48,36, (25,1),59, 83)
        , th_ko_kai(82, 48,53,31, 36,33,51)
        , srp0(25)
        , mdrprg(62)
        , f_ip([16,21,6,23,2])
        , mdrp0rg(11)
        , mdrpmrg(67)
        , add_ip(53,59,[56,29])
        , dx(62,8)
        , dx(21,-8)
        , ix()
        , dh1(46,14)
        , dh2(40,8)
        #y
        , sy()
        , mdap(82)
        , tvtc2(56,[49,51,53,31,33,36, 26,59])
        , tstemtc_2(29)
        , srp0(82)
        , tvbc(40)
        , vhead1(46,[70,76])
        , srp0(82)
        , tvblum(4)
        , alignrp(1)
        , mdrp0rg(8)
        , vhead1(14,[60,64, 62,16,21,6,23,25,2])
        , dx(6,8)
        , dx(16,-8)
        , iy()
        , dh1(43,11)
        ),

    'uni0E10.descless':    #THO THAN
        packline(""
        , tx2_0(63, 22,45, (18,1),50, 64, fstem=tstemtc_1)
        , ip_round(22,1,12)
        , srp0(12)
        , hhead1(6,[60,54,4])
        , ip_round(50,64,34)
        , add_ip(22,34,[25,42])
        , ud2(45)
        , ix()
        , dh1(15)
        , dh2(9)
        #y
        , sy()
        , mdapr(1)
#        , mdrpmb(18)
        , v_top_ro_rua(25,[47,19,50], 42, 37,30,34)
        , mdapr(47)
        , tstemt_2m(22)
        , mdrp0mrw(15)
        , vhead2(9,[51,57,18])
        , iy()
        , dh1(12)
        , dh2(6)
        ),

    'desc.uni0E10':
        packline(""
        , thbsara(23)
        , alignrp(38)
        , alignrp(1)
        , mdrpmb(34)
        , mdrp0rg(29)
        , headstem_1(43)
        , srp0(23)
        , mdrp0rg(19)
        , mdrpmb(48)
        , f_ip([16,6])
        , mdrp0rg(11)
        , mdrpmb(53)
        , ix()
        #y
        , sy()
        , mdap(56)
        , mdrp0mrw(32)
        , vhead2(26,[35,40])
        , mdrp0rg(1)
        , alignrp(4)
        , alignrp(8)
        , mdrpmb(23)
        , shprp2(21)
        , mdrprg(14)
        , f_ip([46,50])
        , iy()
        ),

    'uni0E11':    #THO NANGMONTHO
        packline(""
        , tx2_3(68, 33,27,[65,59,24], 9,(48,8), 15,43, 1,55, 69, dsh_extra="")
        , add_ip(33,43, [36,22,38,40,17])
        , srp0(38)
        , mdrpb(20)
        , mdrpb(19)
        , add_ip(43,1,[7])
        , srp0(7)
        , tstemt_2(50)
        , ud2(24)
        , ix()
        , dh12(25)
        , dh2(30)
        #y
        , sy()
        , mdap(1)
        , alignrp(8)
        , mdrpmb(49)
        , ud2(49)
        , v_head_kho_khuat(40,36,[10,48,15,43,50,7,2,55], 17,22, 19,38, 24,30,[56,62], add1=pl( alignrp(52), tstemtc_2(5)))
        , iy()
        , dh1(33,15)
        , dh2(27,43)
        ),

    'uni0E12':    #THO PHUTHAO
        packline(""
        , tx3_0(83, 48,22, (10,78),(58,3), (61,1),63, 84, fstem='b')
        , th_do_dek(48, 43,42,25, 29,35,[73,67,26])
        , ip_round(42,10,8)
        , srp0(8)
        , tstemt_1(81)
        , add_ip(48,58,[51,19,53,55,14])
        , srp0(53)
        , mdrpb(17)
        , mdrpb(16)
        , ud1(26)
        , ix()
        , dh11(27)
        , dh1(32)
        , dh2(6)
        #y
        , sy()
        , mdap(1)
        , alignrp(42)
        , mdrpmb(25)
        , tvt2(63)
        , v_top_kho_khon(55,51,[48,22,11,58,61], 14,19, 16,53, 32,26,[64,70,35])
        , srp0(1)
        , tvbc(6)
        , tstemtc_1(76)
        , mdrp0rg(10)
        , alignrp(59)
        , tstemt_2(79)
        , shprp2(3)
        , ud2(61)
        , iy()
        , dh1(29,8)
        , dh2(35)
        ),

    'uni0E13':    #NO NEN
        packline(""
        , trs_no_nu(36,38, 47,42,[57,54], 72)
        , uxus_go_front_stem(71, 22,tstemw_1,12, 38)
        , xhead2(18,62,68)
        , th_ko_kai(71, 22,27,8, 12,10,25)
        , ipus_middle_stem(22, 1,tstemw_1,(33,0), 38, dsm="9-8 ")
        , add_ip(27,33,[30,5])
        , ix()
        , dh1(15)
        , dh2(20,45)
        #y  
        , sy()
        , mdap(1)
        , mdrpmb(34)
        , tvt2(38)
        , tvtc2(30,[23,25,27,8,10,12,2,33])
        , tstemtc_2(5)
        , srp0(1)
        , tvbc(20)
        , alignrp(45)
        , vhead1(15,[59,65])
        , srp0(45)
        , tstemtc_1(51)
        , mdrp0rg(39)
        , alignrp(36)
        , tstemt_2(56)
        , shprp2(48)
        , ud2(34)
        , iy()
        , dh2(18,42)
        ),

    'uni0E14':    #DO DEK
        packline(""
        , tx2_0k(51, 32,8, 1,38, 52, [35,5], fstem='b')
        , th_do_dek(32, 27,26,11, 15,21,[48,42,12])
        , ix()
        , ud1(12)
        , dh11(13)
        , dh1(18)
        #y
        , sy()
        , mdap(1)
        , alignrp(26)
        , mdrpmb(11)
        , v_top_kho_khwai(35,[32,8,2,38],5,18,12,[39,45,15,22],do_dek=True)
        , iy()
        , dh1(15)
        , dh2(21)
        ),

    'uni0E15':    #TO TAO
        packline(""
        , tx2_0k(60, 37,13, 1,47, 61,[40,10,42,44,5], fstem='b')
        , th_do_dek(37, 32,31,16, 20,26,[57,51,17])
        , srp0(42)
        , mdrpb(8)
        , mdrpb(7)
        , ud1(17)
        , ix()
        , dh11(18)
        , dh1(23)
        #y
        , sy()
        , mdap(1)
        , alignrp(31)
        , mdrpb(16)
        , v_top_kho_khon(44,40,[37,13,2,47], 5,10, 7,42, 23,17,[48,54,26])
        , iy()
        , dh1(20)
        , dh2(26)
        ),

    'uni0E16':      #THO THUNG
        packline(""
        , tx2_2(46, 22,12, 18,37,43, 1,33, 47)
        , th_ko_kai(46, 22,27,8, 12,10,25)
        , ix()
        , dh1(15)
        , dh2(20)
        #y
        , sy()
        , mdap(1)
        , tvtc2(30,[23,25,27,8,10,12,2,33])
        , tstemtc_2(5)
        , srp0(1)
        , tvbc(20)
        , vhead1(15,[34,40])
        , iy()
        , dh2(18)
        ),

    'uni0E17':      #THO THAHAN
        packline(""
        , tx2_1(42, 16,39,33, 10,(21,9), 1,29, 43)
        , add_ip(21,1,[8])
        , srp0(6)
        , mdrpg(23) 
        , ix()
        , dh1(19)
        , dh2(13)
        #y
        , sy()
        , mdap(1)
        , alignrp(9)
        , tvtc2(19,[22,23,8,2,29])
        , alignrp(26)
        , tstemtc_2(5)
        , vhead2(13,[30,36])
        , ud2(22)
        , iy()
        , dh1(16)
        ),

    'uni0E18':      #THO THONG
        packline(""
        , tx2_0(45, 3,43, 39,34, 46)
        , srp0(3)
        , mdrp0mb(7)
        , mdrpmb(28)
        , ip_round(34,46,18)
        , add_ip(7,18,[10,25,15,20])
        , ix()
        #y
        , sy()
        , mdap(1)
        , tstemt_1(2)
        , shprp2(44)
        , v_top_ro_rua(10,[30,40,34], 25, 20,15, 18)
        , mdapr(30)
        , tstemt_2(4)
        , mdrpmb(43)
        , iy()
        ),

    'uni0E19':      #NO NU
        packline(""
        , trs_no_nu(16,18, 28,22,[51,47], 54)
        , uxus_go_front_stem(53, 1,tstemw_1,(12,0), 18, dsf="12-8 14+8 16-8 ")
        , xhead1(7,41,35)
        , ix()
        , dh1(10)
        , dh2(25,4)
        #y
        , sy()
        , mdap(0)
        , mdrpmb(13)
        , tvt2(18)
        , tvtc2(10)
        , vhead2(4,[32,38])
        , srp0(0)
        , tvbc(25)
        , tstemtc_1(44)
        , mdrp0rg(16)
        , alignrp(19)
        , tstemt_2(29)
        , shprp2(50)
        , iy()
        , dh1(7)
        , dh2(22)
        ),  

    'uni0E1A':      #BO BAIMAI
        packline(""
        , tx2_1(35, 9,32,26, 3,14, 18,20, 36, dsf="12-8 ")
        , ix()
        , dh1(12)
        , dh2(6)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(2)
        , shprp2(15)
        , tvt2(20)
        , tvtc2(12)
        , vhead2(6,[23,29])
        , iy()
        , dh1(9)
        ),

    'uni0E1B':      #PO PLA
        packline(""
        , tx2_1(35, 9,32,26, 3,14, 18,20, 36, dsf="12-8 ")
        , ix()
        , dh1(12)
        , dh2(6)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(2)
        , shprp2(15)
        , tvtpo(20)
        , tvtc2(12)
        , vhead2(6,[23,29])
        , iy()
        , dh1(9)
        ),

    'uni0E1C':      #PHO PHUNG
        packline(""
        , tx2_2(33, 4,(15,3), 10,24,30, (18,1),20, 34)
        , add_ip(15,18,[17,2])
        , ix()
        , dh1(7)
        , dh2(13)
        #y  
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvt2(20)
        , tvtc2(8,[16,18])
        , vhead2(13,[21,27])
        , add_ip(13,1,[17,2])
        , iy()
        , dh2(10)
        ),  

    'uni0E1D':      #FO FA
        packline(""
        , tx2_2(33, 4,(15,3), 10,24,30, (18,1),20, 34)
        , add_ip(15,18,[17,2])
        , ix()
        , dh1(7)
        , dh2(13)
        #y  
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvtpo(20)
        , tvtc2(8,[16,18])
        , vhead2(13,[21,27])
        , add_ip(13,1,[17,2])
        , iy()
        , dh2(10)
        ),  

    'uni0E1E':      #PHO PHAN
        packline(""
        , tx2_1(33, 10,30,24, 4,(15,3), (18,1),20, 34, dsf="10-8 12-8 ")
        , add_ip(15,18,[17,2])
        , ix()
        , dh1(13)
        , dh2(7)
        #y
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvt2(20)
        , tvtc2(13,[2,16,17,18])
        , vhead2(7,[21,27])
        , iy()
        , dh1(10)
        ),

    'uni0E1F':      #FO FAN
        packline(""
        , tx2_1(33, 10,30,24, 4,(15,3), (18,1),20, 34, dsf="10-8 12-8 ")
        , add_ip(15,18,[17,2])
        , ix()
        , dh1(13)
        , dh2(7)
        #y
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvtpo(20)
        , tvtc2(13,[2,16,17,18])
        , vhead2(7,[21,27])
        , iy()
        , dh1(10)
        ),

    'uni0E20':    #PHO SAMPHAO
        packline(""
        , tx2_1(46, 17,43,37, 22,12, 1,33, 47)
        , th_ko_kai(46, 22,27,8, 12,10,25)
        , add_ip(27,33,[30,5])
        , ix()
        , dh1(20)
        , dh2(15)
        #y
        , sy()
        , mdap(1)
        , tvtc2(30,[23,25,27,8,10,12,2,33])
        , tstemtc_2(5)
        , srp0(1)
        , tvbc(15)
        , vhead1(20,[34,40])
        , iy()
        , dh1(17)
        ),

    'uni0E21':      #MO MA
        packline(""
        , tx2_1(50, 18,40,34, (12,45),(24,4), (28,1),30, 51, dsf="10-8 ")
        , ip_round(18,12,10)
        , tstemt_1(48)
        , ix()
        , dh1(21)
        , dh2(15,7)
        #y
        , sy()
        , mdap(1)
        , mdrpmb(28)
        , tvt2(30)
        , tvtc2(21)
        , vhead2(15,[31,37])
        , srp0(1)
        , tvbc(6)
        , tstemtc_1(43)
        , mdrp0rg(12)
        , alignrp(25)
        , tstemt_2(46)
        , shprp2(4)
        , iy()
        , dh1(18,10)
        ),
    
    'uni0E22':    #YO YAK
        packline(""
        , tx2_0(57, 3,32, 39,41, 58)
        , srp0(3)
        , mdrprg(27)
        , f_ip([7])
        , mdrp0rg(10)
        , tstemw_1(21)
        , mdrp0rg(16)
        , xhead0(48,54,direction='-')
        , ix()
        , dh1(13)
        , dh2(19)
        #y
        , sy()
        , mdap(57)
        , tvbc(0)
        , tstemt_1(36)
        , tvt2(41)
        , tvtc2(13)
        , vhead2(19,[45,51,21])
        , ip_round(19,36,25)
        , tstemt_2(29)
        , f_ip([7])
        , iy()
        , dh2(16)
        ),

    'uni0E23':    #RO RUA
        packline(""
        , tx2_0(53, 13,33, 8,38, 54, fstem=tstemtc_1)
        , srp0(8)
        , xhead1(3,50,44)
        , srp0(54)
        , mdrpmrw(24)
        , add_ip(13,24,[16,31,26,21])
        , ud2(33)
        , ix() 
        , dh1(6)
        , dh11(1), dh12(40)
        #y
        , sy() 
        , mdap(53)
        , v_top_ro_rua(16,[34,9,38], 31, 26,21, 24)
        , srp0(34)
        , tstemtc_2(12)
        , srp0(53)
        , tvbc(0)
        , vhead1(6,[41,47])
        , iy()
        , dh1(3)
        ),  

    'uni0E24':      #RU
        packline(""
        , tx2_2(46, 22,12, 18,37,43, 1,33, 47)
        , th_ko_kai(46, 22,27,8, 12,10,25)
        , ix()
        , dh1(15)
        , dh2(20)
        #y
        , sy()
        , mdap(46)
        , tvtc2(30,[23,25,27,8,10,12,2,33])
        , tstemtc_2(5)
        , srp0(46)
        , tvblu(1)
        , tvbc(20)
        , vhead1(15,[34,40])
        , iy()
        , dh2(18)
        ),

    'uni0E25':      #LO LING
        packline(""
        , tx2_2(50, 18,8, 14,41,47, (1,25),37, 51)
        , add_ip(50,18,[32])
        , add_ip(18,1,[22,5])
        , add_ip(32,37,[34,29])
        , ix()
        , dh1(11)
        , dh2(16)
        #y
        , sy()
        , mdap(1)
        , tvtc2(34,[19,8,26,37,25,2,22,31])
        , tstemtc_2(29)
        , mdapr(31)
        , mdapr(22)
        , tstemtc_2(5)
        , srp0(1)
        , tvbc(16)
        , vhead1(11,[38,44])
        , ud2(25)
        , iy()
        , dh2(14)
        ),

    'uni0E26':    #LU
        packline(""
        , tx2_1(46, 17,43,37, 22,12, 1,33, 47)
        , th_ko_kai(46, 22,27,8, 12,10,25)
        , add_ip(27,33,[30,5])
        , ix()
        , dh1(20)
        , dh2(15)
        #y
        , sy()
        , mdap(46)
        , tvtc2(30,[23,25,27,8,10,12,2,33])
        , tstemtc_2(5)
        , srp0(46)
        , tvblu(1)
        , tvbc(15)
        , vhead1(20,[34,40])
        , iy()
        , dh1(17)
        ),

    'uni0E27':    #WO WAEN
        packline(""
        , tx1(34, 7,19, 35)
        , srp0(7)
        , xhead1(2,31,25)
        , mdapr(14)
        , mdrpb(13)
        , add_ip(14,19,[16,11])
        , ix()
        , dh1(5)
        , dh11(1), dh12(21)
        #y
        , sy()
        , mdap(34)
        , tvtc2(16,[8,19,13])
        , tstemtc_2(11)
        , mdapr(13)
        , srp0(34)
        , tvbc(0)
        , vhead1(5,[22,28])
        , iy()
        , dh1(2)
        ),  

    'uni0E28':    #SO SALA
        packline(""
        , tx2_0k(64, 38,8, 1,51, 65, [41,5])
        , th_kho_khwai(38, 33,28,11, 16,[61,55])
        , ix()
        , dh1(13)
        , dh2(19)
        #y
        , sy()
        , mdap(1)
        , alignrp(30)
        , v_top_kho_khwai(41,[38,8,11,2,51],5, 13,19,[52,58,21], add1=mdrpmrg(47))
        , ud2(11)
        , iy()
        , dh2(16)
        ),

    'uni0E29':      #SO RUSI
        packline(""
        , tx2_1(73, 9,58,52, 3,15, (19,38),(46,40), 74)
        , srp0(38)
        , mdrp0mrw(30)
        , mdrprg(25,"")
        , f_ip([70,64,34])
        , ix()
        , dh1(12,27)
        , dh2(6)
        #y  
        , sy()
        , mdap(1)
        , tstemt_1(2)
        , shprp2(16)
        , tvt2(40)
        , tvtc2(12,[27])
        , vhead2(6,[49,55])
        , mdapr(27)
        , mdrp0rg(22)
        , f_ip([61,67,33,20,41,46])
        , tstemt_1(36)
        , iy()
        , dh1(9,25)
        ),

    'uni0E2A':      #SO SUA
        packline(""
        , tx2_2(54, 18,8, 14,45,51, (1,25),41, 55)
        , add_ip(54,18,[31])
        , add_ip(18,1,[22,5])
        , add_ip(31,41,[33,28])
        , ix()
        , dh1(11)
        , dh2(16)
        #y
        , sy()
        , mdap(1)
        , tvtc2(33,[19,8,26,41,25,2,22,30])
        , mdrpmrg(37)
        , tstemtc_2(28)
        , mdapr(30)
        , mdapr(22)
        , tstemtc_2(5)
        , srp0(1)
        , tvbc(16)
        , vhead1(11,[42,48])
        , ud2(25)
        , iy()
        , dh2(14)
        ),

    'uni0E2B':      #HO HIP
        packline(""
        , tx2_1(64, 15,49,43, 9,(20,8), 1,39, 65)
        , add_ip(20,1,[7])
        , srp0(7)
        , mdrpb(22) 
        , srp0(39)
        , mdrp0rg(34)
        , mdapr(34,"20-8 ")
        , hhead2(28,[61,55,25,37,4])
        , dx(25,8)
        , dx(37,-8)
        , ix()
        , dh1(18,31)
        , dh2(12)
        #y
        , sy()
        , mdap(1)
        , alignrp(8)
        , tvtc2(18,[21,22,7,2,39])
        , alignrp(31)
        , vhead2(12,[(40,52),(46,58)])
        , srp0(52)
        , tstemtc_2(4)
        , f_ip([25,37])
        , iy()
        , dh1(15,28)
        , dh2(34)
        ),

    'uni0E2C':      #LO CHULA
        packline(""
        , tx2_1(55, 10,45,39, 4,(15,3), (18,1,48),(35,27), 56, dsf="10-8 ")
        , srp0(18)
        , mdrp0rg(22)
        , tstemt_1(53)
        , add_ip(15,18,[17,2])
        , ix()
        , dh1(13,24)
        , dh2(7), dh11(20)
        #y
        , sy()
        , mdap(1)
        , alignrp(3)
        , tvtc2(13,[17,2,16,18])
        , vhead2(7,[36,42])
        , srp0(13)
        , mdrp0mrg(24)
        , mdrprg(33)
        , vhead2(19,[48,51,35,28])
        , iy()
        , dh1(10,22)
        ),

    'uni0E2D':      #O ANG
        packline(""
        , tx2_2(50, 3,15, 10,41,47, 22,34, 51)
        , ip_round(50,3,29)
        , add_ip(29,34,[31,26])
        , ix()
        , dh1(7)
        , dh2(13)
        #y
        , sy()
        , mdap(50)
        , tvtc2(31,[23,34,28])
        , tstemtc_2(26)
        , mdapr(28)
        , mdrp0mrw(7)
        , vhead2(13,[38,44])
        , srp0(50)
        , tvbc(0)
        , tstemt_1(19)
        , iy()
        , dh2(10)
        ),  

    'uni0E2E':      #HO NOKHUK
        packline(""
        , tx2_2(71, 3,15, 10,51,57, 22,44, 72)
        , ip_round(71,3,31)
        , tstemtc_1(68)
        , add_ip(31,44,[35,65,60,28, 37,42,63,25])
        , ud1(63)
        , ud2(42)
        , ix()
        , dh1(7)
        , dh2(13)
        #y
        , sy()
        , mdap(71)
        , tvtc2(35,[23,44])
        , mdrpmrg(40)
        , tstemtc_2(65)
        , mdrp0rg(28)
        , f_ip([37,42,63,25])
        , tstemt_1(60)
        , mdrp0mrw(7)
        , vhead2(13,[48,54])
        , srp0(71)
        , tvbc(0)
        , tstemt_1(19)
        , dx(25,8)
        , dx(37,-8)
        , iy()
        , dh2(10)
        ),

    'uni0E2F':      #PAIYAN NOI
        packline(""
        , tx2_0(42, 12,40, 1,32, 43, fstem=tstemtc_1, dsf="11-8 12-8 ")
        , mdrp0rg(18)
        , headstem_2(35)
        , ix()  
        , dh1(15)
        #y  
        , sy()
        , mdap(1)
        , tvtc2(15)
        , alignrp(29)
        , tstemw_2(4)
        , vhead2(21,[33,38])
        , mdrp0rg(9)
        , tstemt_1(24)
        , iy()
        , dh2(18)
        ),  

    'uni0E30':      #SARA A
        packline(""
        , tx2_0(68, (3,37),(31,65), (18,52),(19,53), 69, fstem="")
        , mdrpb(12)
        , shprp2(46)
        , mdrp0rg(8)
        , alignrp(42)
        , headstem_2(25)
        , shprp2(59)
        , ix()
        , dh1(39,5)
        #y  
        , sy()
        , mdapr(0)
        , tstemt_1(15)
        , mdrp0rg(5,"")
        , mdrprg(19)
        , vhead2(11,[22,28])
        #
        , mdapr(34)
        , tstemt_1(49)
        , mdrp0rg(39,"")
        , mdrprg(53)
        , vhead2(45,[56,62])
        , iy()
        , dh2(8,42)
        ),

    'uni0E31':      #MAI HAN-AKAT
        packline(""
        , mdapr(7)
        , mdrp0rg(17)
        , mdrpmb(18)
        , srp0(7)
        , headstem_2(24)
        , mdrp0rg(3)
        , mdrpmrb(30)
        , mdrpmb(11)
        , ix()
        , dh1(5)
        , dh12(9)
        #y  
        , sy()
        , tvtsara(0)
        , tstemt_1(14)
        , mdrp0rg(5,"")
        , mdrprg(18)
        , vhead2(10,[21,27])
        , iy()
        , dh2(7)
        ),

    'uni0E32':    #SARA AA
        packline(""
        , tx1(14, 1,13, 15)
        , mdapr(8)
        , mdrpb(7)
        , add_ip(8,13,[10,5])
        , ix()
        #y
        , sy()
        , mdap(1)
        , tvtc2(10,[7,2,13])
        , tstemtc_2(5)
        , mdapr(7)
        , iy()
        ),  

    'uni0E34':    #SARA I
        packline(""
        , h_sara_i(0,13,19,7)
        , ix()
        #y
        , sy()
        , v_sara_i(0,13,2,21,16,10)
        , iy()
        ),
    
    'uni0E35':    #SARA II
        packline(""
        , h_sara_i(0,17,23,7)
        , srp0(0)
        , mdrp0mrb(13)
        , mdrpmb(15)
        , ix()
        #y
        , sy()
        , v_sara_i(0,17,2,25,20,10)
        , mdrpmg(14)
        , iy()
        ),
    
    'uni0E36':    #SARA UE
        packline(""
        , h_sara_i(0,23,29,7)
        , srp0(23)
        , mdrp0mrg(18)
        , mdrp0rg(12,"15-8 ")
        , f_ip([43,37,21])
        , ix()
        #y
        , sy()
        , v_sara_i(0,23,2,31,26,10)
        , mdrp0mrg(15)
        , mdapr(15)
        , mdrp0rg(21,"15-8 ")
        , f_ip([34,40,12])
        , iy()
        ),

    'uni0E37':    #SARA UUE
        packline(""
        , h_sara_i(0,22,28,7)
        , srp0(22)
        , mdrp0rg(17)
        , mdrpmb(19)
        , mdrp0mrw(14)
        , mdrp0mrb(12)
        , mdrpmb(14)
        , ix()
        #y  
        , sy()   
        , v_sara_i(0,22,2,30,25,10)
        , mdrp0mg(14)
        , alignrp(19)
        , add_ip(10,2,[12,15,17,20])
        , iy()
        ),  

    'uni0E38':    #SARA U
        packline(""
        , thbsara(1)
        , alignrp(17)
        , tstemw_1(13)
        , mdrp0rg(7)
        , headstem_1(23)
        , ix()
        #y  
        , sy()
        , mdap(26) 
        , mdrp0mrw(10)
        , vhead2(4,[14,20])
        , mdrpmb(1)
        , iy()
        ),  

    'uni0E39':    #SARA UU
        packline(""
        , thbsara(20)
        , tstemw_1(22)
        , mdrp0mrw(15)
        , mdrp0mrb(3)
        , alignrp(28)
        , tstemw_1(15)
        , mdrp0rg(9)
        , headstem_1(34)
        , ix() 
        #y  
        , sy()
        , mdap(37)
        , mdrp0mrw(12)
        , mdrpg(22)
        , vhead2(6,[25,31])
        , mdrp0mrb(1)
        , tstemt_1(18)
        , iy()
        ),

    'uni0E3A':    #PHINTHU
        packline(""
        , thbsara(9)
        , mdrpmrg(3)
        , ix() 
        #y  
        , sy()
        , mdap(12)
        , mdrp0mrw(6)
        , mdrpmrg(0)
        , iy() 
        ),

    'uni0E3F':    #THAI CURRENCY SYMBOL BAHT
        packline(""
        , tx2_0(56, 7,(32,47), 39,25, 57, fstem="b",rstem="b")
        , srp0(39)
        , mdrp0g(52)
        , mdrpmb(19)
        , ipus_middle_stem(33, (30,1,43,13),tstemtc_1,(42,29,55,15), 52, dsm="16+8 ")
        , ix()
        #y  
        , sy()
        , mdapr(2)
        , alignrp(29)
        , mdrpmrg(1)
        , tstemt_1(30)
        , shprp2(36)
        , mdapr(13)
        , alignrp(16)
        , mdrpmrg(14)
        , tstemt_2(44)
        , shprp2(55)
        , ipus_middle_stem(13, (43,49),tstemt_2,(31,42), 30)
        , f_ip([22])
        , iy()
        ),

    'uni0E40':    #SARA E
        packline(""
        , trs_e(3,5, 11,16,22, 26)
        , ix()
        , dh1(8)
        , dh11(1), dh12(12)
        #y  
        , sy()
        , mdap(25)
        , tvt2(5)
        , tvbc(0)
        , vhead1(8,[13,19])
        , iy()
        , dh2(11)
        ),

    'uni0E42':    #SARA O
        packline(""
        , mdapr(7)
        , tstemtc_1(26)
        , mdapr(17)
        , trs_e(3,29, 35,40,44, 48)
        , add_ip(7,17,[9,24,14,19])
        , ud2(26)
        , ix()
        , dh1(32)
        , dh11(1), dh12(36)
        #y  
        , sy()
        , mdap(47)
        , tvbc(0)
        , vhead1(32,[37,42])
        #
        , mdap(9)
        , tstemtc_2(24)
        , 'RTDG'
        , mdrp0rg(19)
        , 'RTG'
        , tstemt_1(13)
        , add_ip(9,0,[7,26,4,29])
        , iy()   
        , dh2(35)
        ),

    'uni0E43':    #SARA AI MAI MUAN
        packline(""
        , trs_e(3,44, 50,56,62, 66)
        , mdrp0mrg(16)
        , mdrpb(32)
        , mdrp0rg(38)
        , f_ip([26,20])
        , mdrpb(10)
        , ix()
        , dh1(47)
        , dh11(1), dh12(52)
        #y  
        , sy()
        , mdap(65)
        , tvbc(0) 
        , vhead1(47,[53,59])
        #
        , mdap(41)
        , tstemtc_2m(7)
        , mdrp0mrw(29)
        , mdrpg(18)
        , mdrp0mrg(35)
        , mdrpb(13)
        , iy()
        , dh2(50)
        ),

    'uni0E44':    #SARA AI MAIMALAI
        packline(""
        , trs_e(2,24, 30,36,42, 46)
        , mdrp0rg(14)
        , f_ip([17,18,19, 8,11])
        , ix()
        , dh1(27)
        , dh11(1), dh12(32)
        #y  
        , sy()
        , mdap(45)
        , tvbc(0)
        , vhead1(27,[33,39])
        #
        , mdap(21)
        , tstemtc_2(6)
        , mdrprg(15)
        , mdrp0rg(11)
        , f_ip([18])
        , ud2(18)
        , iy()
        , dh2(30)
        ),

    'uni0E45':    #LAKKHANGYAO
        packline(""
        , tx1(14, 1,13, 15)
        , mdapr(8)
        , add_ip(8,13,[10,5])
        , ix()
        #y
        , sy()
        , mdap(14)
        , tvtc2(10,[7,2,13])
        , tstemtc_2(5)
        , mdapr(7)
        , srp0(14)
        , tvblu(1)
        , iy()
        ),

    'uni0E46':    #MAIYAMOK
        packline(""
        , tx2_0(50, 24,14, 4,34, 51, fstem=tstemtc_1)
        , mdrpmrb(47)
        , mdrp0rg(19,"15+8 16+8 ")
        , headstem_2(41)
        , add_ip(24,34,[27,12,31,7,29])
        , srp0(29)
        , mdrpb(10)
        , mdrpb(9)
        , ix()
        , dh1(16)
        , dh2(22)
        #y
        , sy()
        , mdap(50)
        , tvtc2(27,[5,34])
        , alignrp(31)
        , tstemtc_2(12)
        , shprp2(7)
        , 'RUTG'
        , mdrp0rg(9)
        , 'RTG'
        , mdrpb(29)
        , mdrp0rg(16)
        , mdapr(16)
        , vhead2(22,[38,44])
        #
        , srp0(50)
        , tvblu(1)
        , iy()
        , dh2(19)
        ),

    'uni0E47':    #MAITAIKHU
        packline(""
        , mdapr(57)
        , mdrp0rg(24)
        , mdrpmb(25)
        , srp0(57)
        , 'RDTG', mdrpmrg(51), 'RTG'
        , f_ip([69,63,43])
        , mdrp0rg(13)
        , f_ip([39,10,41,5])
        , mdrpmb(36)
        , dx(43,8)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , alignrp(10)
        , mdrpmrb(46)
        , 'RDTG', mdrp0rg(54), 'RTG'
        , f_ip([60,66,43,41,5,39])
        , mdrp0mrw(28)
        , mdrp0mrb(16)
        , mdrpmrg(25)
        , iy()
        ),

    'uni0E47.high':    #MAITAIKHU
        packline(""
        , mdapr(57)
        , mdrp0rg(24)
        , mdrpmb(25)
        , srp0(57)
        , 'RDTG', mdrpmrg(51), 'RTG'
        , f_ip([69,63,43])
        , mdrp0rg(13)
        , f_ip([39,10,41,5])
        , mdrpmb(36)
        , dx(43,8)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , alignrp(10)
        , mdrpmrb(46)
        , 'RDTG', mdrp0rg(54), 'RTG'
        , f_ip([60,66,43,41,5,39])
        , mdrp0mrw(28)
        , mdrp0mrb(16)
        , mdrpmrg(25)
        , iy()
        ),

    'uni0E48':    #MAI EK
        packline(""
        , mdap(4)
        , mdrpmb(5)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrpb(5)
        , iy()
        ),

    'uni0E48.low':    #MAI EK
        packline(""
        , thbsara(4)
        , mdrpmb(5)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , mdrpb(5)
        , iy()
        ),

    'uni0E49':    #MAI THO
        packline(""
        , mdapr(20)
        , mdrpmb(21)
        , mdrp0mrw(14)
        , mdrp0rg(8)
        , f_ip([33,27,4,17])
        , mdrprg(1)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , mdrp0rg(4)
        , f_ip([2,17])
        , mdrp0rg(11)
        , f_ip([24,30])
        , mdrprg(21)
        , iy()
        ),

    'uni0E49.low':    #MAI THO
        packline(""
        , mdapr(20)
        , mdrpmb(21)
        , mdrp0mrw(14)
        , mdrp0rg(8)
        , f_ip([33,27,4,17])
        , mdrprg(1)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , mdrp0rg(4)
        , f_ip([2,17])
        , mdrp0rg(11)
        , f_ip([24,30])
        , mdrprg(21)
        , iy()
        ),

    'uni0E4A':    #MAI TRI
        packline(""
        , mdapr(38)
        , mdrpmb(42)
        , mdrp0mrg(32)
        , mdrp0mb(4)
        , mdrpmb(32)
        , mdrp0rb(22)
        , f_ip([25,11,27,29,6])
        , mdrprb(16)
        , f_ip([54,48,13])
        , srp0(27)
        , mdrpb(9)
        , mdrpb(8)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
        , alignrp(19)
        , mdrpmb(1)
        , shprp2(35)
        , mdrprg(13)
        , f_ip([45,51])
        , mdrp0rg(25)
        , alignrp(29)
        , mdrprg(41)
        , mdrpmb(11)
        , shprp2(6)
        , iy()
        ),

    'uni0E4A.low':    #MAI TRI
        packline(""
        , mdapr(38)
        , mdrpmb(42)
        , mdrp0mrg(32)
        , mdrp0mb(4)
        , mdrpmb(32)
        , mdrp0rb(22)
        , f_ip([25,11,27,29,6])
        , mdrprb(16)
        , f_ip([54,48,13])
        , srp0(27)
        , mdrpb(9)
        , mdrpb(8)
        , ix()
        #y
        , sy()
        , tvtsara(0)
        , alignrp(19)
        , mdrpmb(1)
        , shprp2(35)
        , mdrprg(13)
        , f_ip([45,51])
        , mdrp0rg(25)
        , alignrp(29)
        , mdrprg(41)
        , mdrpmb(11)
        , shprp2(6)
        , iy()
        ),

    'uni0E4B':    #MAI CHATTAWA
       packline(""
        , mdapr(6)
        , mdrpmg(4)
        , mdrp0mb(7)
        , f_ip([1,2,5,0,11,8])
        , mdrpmg(10)
        , ix()
        #y  
        , sy()
        , tvtwanayuk(0)
        , mdrp0mrg(11)
        , alignrp(2)
        , mdrpg(0)
        , mdrp0mb(8)
        , alignrp(5)
        , mdrpg(7)
        , iy()
        ),

    'uni0E4B.low':    #MAI CHATTAWA
        packline(""
        , mdapr(6)
        , mdrpmg(4)
        , mdrp0mb(7)
        , f_ip([1,2,5,0,11,8])
        , mdrpmg(10)
        , ix()
        #y  
        , sy()
        , tvtwanayuk(0)
        , mdrp0mrg(11)
        , alignrp(2)
        , mdrpg(0)
        , mdrp0mb(8)
        , alignrp(5)
        , mdrpg(7)
        , iy()
        ),

    'uni0E4C':    #THANTHAKAT
        packline(""
        , mdapr(23)
        , mdrp0rg(11)
        , mdrpmb(12)
        , srp0(23)
        , mdrpmrg(3)
        , f_ip([35,29,20])
        , add_ip(20,12,[6,18])
        , ix()
        #y  
        , sy()
        , tvtwanayuk(0)
        , mdrp0rg(20)
        , f_ip([26,32])
        , mdrpmrg(12)
        , f_ip([6])
        , srp0(6)
        , mdrpmb(18)
        , iy()
        ),

    'uni0E4C.low':    #THANTHAKAT
        packline(""
        , mdapr(23)
        , mdrp0rg(11)
        , mdrpmb(12)
        , srp0(23)
        , mdrpmrg(3)
        , f_ip([35,29,20])
        , add_ip(20,12,[6,18])
        , ix()
        #y  
        , sy()
        , tvtsara(0)
        , mdrp0rg(20)
        , f_ip([26,32])
        , mdrpmrg(12)
        , f_ip([6])
        , srp0(6)
        , mdrpmb(18)
        , iy()
        ),

    'uni0E4D':    #NIKHAHIT
        packline(""
        , mdap(9)
#        , vhead2(3,[21,15])
, mdrpmb(15), mdrp0mrg(3), mdrpmb(21)
        , ix()
        #y
        , sy()
        , tvtsara(0)
#        , vhead1(6,[12,18])
, mdrpmb(12), mdrp0mrg(6), mdrpmb(18)
        , iy()
        ),

    'uni0E4D.high':    #NIKHAHIT
        packline(""
        , mdap(9)
, mdrpmb(15), mdrp0mrg(3), mdrpmb(21)
        , ix()
        #y
        , sy()
        , tvtwanayuk(0)
, mdrpmb(12), mdrp0mrg(6), mdrpmb(18)
        , iy()
        ),

    'uni0E4E':    #YAMAKKAN
        packline(""
        , thbsara(16)
        , mdrpmb(23)
        , mdrp0rg(10)
        , mdrpmrb(33)
        , f_ip([28,38])
        , mdrp0rg(3)
        , mdrpmb(44)
        , mdrprg(50)
        , ix()
        #
        , sy()
        , tvtsara(0)
        , mdrpmb(47)
        , mdrp0rg(6)
        , mdrpmb(41)
        , mdrprg(35)
        , mdrp0mrg(13)
        , mdrpmb(25)
        , iy()
        ),

    'uni0E4F':    #FONGMAN
        packline(""
        , mdapr(49) 
        , mdrp0mrw(9,"9+8 ")
        , mdrp0mrb(15)
        , mdrpmrw(33)
        , srp0(9)
        , mdrp0rg(3)
        , mdrp0mrb(21)
        , mdrpmrw(27)
        , add_ip(27,33,[45,39])
        , ix()
        #y  
        , sy()
        , mdapr(0) 
        , mdrp0mrb(12)
        , mdrpmrw(24)
        , srp0(0)
        , mdrp0rg(6)
        , mdrp0mrb(18)
        , mdrpmrw(30)
        , add_ip(30,24,[36,42])
        , iy()
        ),

    'uni0E50':    #THAI DIGIT ZERO
        packline(""
        , tx2_0(24, 3,21, 15,9, 25)
        , ix()
        #y  
        , sy()
        , mdap(24)
        , tvtnc(6)
        , tstemt_2(18)
        , srp0(24)
        , tvbc(0)
        , tstemt_1(12)
        , iy()
        ),

    'uni0E51':    #THAI DIGIT ONE
        packline(""
        , tx2_0(52, 3,22, 16,9, 53)
        , ip_round(3,16,32)
        , hhead1(38,[49,43])
        , ix()
        , dh1(35)
        , dh2(29)
        #y  
        , sy()
        , mdapr(52)
        , tvtnc(6,[3,22,16,9])
        , tstemtc_2(19)
        , srp0(52)
        , tvbc(0)
        , alignrp(13)
        , tstemt_2(12)
        , tstemtc_1(25)
        , ip_round(19,25,30)
        , vhead1(35,[40,46])
        , iy()
        , dh1(32)
        , dh2(38)
        ),

    'uni0E52':    #THAI DIGIT TWO
        packline(""
        , tx2_0(59, 3,9, 15,46, 60)
        , ip_round(9,15,37)
        , tstemtc_1(26)
        , shprp2(56)
        , mdrp0rg(31)
        , headstem_2(50)
        , add_ip(37,46,[40,23,42,44,18])
        , srp0(42)
        , mdrpg(21)
        , mdrpg(20)
        , ix()
        , dh1(28)
        , dh2(34)
        #y  
        , sy()
        , mdapr(0)
        , tstemt_1(13)
        , tvtnc(44)
        , alignrp(40)
        , mdrpmrg(7)
        , tstemt_2(18)
        , shprp2(23)
        , 'RUTG' , mdrp0mrg(20), 'RTG'
        , mdrpb(42)
        , srp0(44)
        , mdrp0rg(28)
        , vhead2(34,[48,53])
        , iy()
        , dh2(31)
        ),

    'uni0E53':    #THAI DIGIT THREE
        packline(""
        , tx2_0(55, 3,31, 20,13, 56)
        , mdrp0rg(41)
        , hhead2(35,[52,46])
        , add_ip(3,13,[6,28,8,10,23])
        , srp0(8)
        , mdrpg(26)
        , mdrpg(25)
        , ix()
        , dh1(38)
        #y  
        , sy()
        , mdap(55)
        , tvtnc(6,[3,31,20,13])
        , alignrp(10)
        , tstemt_2(28)
        , shprp2(23)
        , 'RUTG', mdrp0rg(25), 'RTG'
        , mdrpmb(8)
        , srp0(55)
        , tvbc(0)
        , alignrp(16)
        , vhead1(38,[43,49])
        , iy()
        , dh1(35)
        , dh2(41)
        ),

    'uni0E54':    #THAI DIGIT FOUR
        packline(""
        , tx2_0(61, 3,17, 8,12, 62, rstem='')
        , add_ip(3,12,[25,41])
        , mdapr(41)
        , mdapr(25)
        , mdrpmb(58)
        , mdrp0rg(31)
        , f_ip([36,22,44])
        , headstem_2(52)
        , ix()
        , dh1(28)
        , dh2(34)
        #y  
        , sy()
        , mdap(0)
        , alignrp(42)
        , tstemtc_1(20)
        , mdrpmb(39)
        , mdrp0mrg(28)
        , vhead2(34,[49,55])
        , srp0(28)
        , mdrp0mrw(15)
        , mdrpmb(6)
        , mdrprg(10)
        , iy()
        , dh1(25)
        , dh2(31)
        ),

    'uni0E55':    #THAI DIGIT FIVE
        packline(""
        , tx2_0(83, 3,32, 18,23, 84, rstem='')
        , add_ip(3,23,[8,40,55])
        , mdapr(55)
        , mdapr(40)
        , mdrpmb(72)
        , mdrp0rg(45)
        , f_ip([50,37,58])
        , headstem_2(66)
        , mdapr(8)
        , mdrpmb(81)
        , mdrp0rg(14)
        , mdrpmb(77)
        , ix()
        , dh1(42,11)
        , dh2(48)
        #y
        , sy()
        , mdap(0)
        , alignrp(56)
        , tstemtc_1(35)
        , mdrpmb(53)
        , mdrp0rg(42)
        , vhead2(48,[63,69])
        , srp0(42)
        , mdrp0mrw(29)
        , mdrpmb(16)
        , f_ip([6,75,25])
        , mdrpmrg(21)
        , mdrp0rg(11)
        , mdrpmb(79)
        , iy()
        , dh1(8)
        , dh2(14,45)
        ),

    'uni0E56':    #THAI DIGIT SIX
        packline(""
        , tx2_0(56, 3,53, 19,41, 57, fstem=tstemtc_1)
        , mdrprg(30)
        , mdrp0rg(9)
        , f_ip([14])
        , headstem_2(47)
        , srp0(3)
        , mdrp0rg(25)
        , mdrpmb(36)
        , f_ip([24])
        , add_ip(3,41,[38,22,16,0])
        , ix()
        , dh1(6)
        #y  
        , sy()
        , mdap(56)
        , tvtnc(38,[19,41,24]) 
        , tstemt_2(22)
        , mdrprg(31)
        , mdapr(24)
        , mdrpmb(36)
        , mdrp0mrw(6)
        , vhead2(12,[44,50])
        , srp0(56)
        , tvbc(0)
        , tstemt_1(16)
        , iy()
        , dh1(3)
        , dh2(9)
        ),

    'uni0E57':    #THAI DIGIT SEVEN
        packline(""
        , tx2_0(68, 33,16, 49,54, 69, rstem=tstemtc_1)
        #, ipus_middle_stem(33, 5,tstemw_1,43, 49, mround=70,dsm="17-8 ")
        , ipus_middle_stem(33, 5,tstemw_1,43, 49)
        , srp0(33)
        , mdrp0rg(27)
        , hhead2(21,[65,60])
        , add_ip(33,43,[36,13,38,40,8])
        , srp0(38)
        , mdrpb(11)
        , mdrpb(10)
        , ix()
        , dh1(24)
        , dh2(30)
        #y  
        , sy()
        , mdap(2)
        , tstemtc_1(46)
        , tvtnc(40,[33,16,5,43])
        , alignrp(36)
        , mdrprg(51)
        , tstemt_2(8)
        , shprp2(13)
        , srp0(2)
        , tvbc(30)
        , alignrp(0)
        , vhead1(24,[58,63])
        , iy()
        , dh1(21)
        , dh2(27)
        ),

    'uni0E58':    #THAI DIGIT EIGHT
        packline(""
        , tx2_0(76, 12,38, 23,28, 77, fstem=tstemtc_1,rstem=tstemt_1)
        , ip_round(12,28,61)
        , hhead2(55,[73,67,51])
        , add_ip(38,55,[44,5,42])
        , srp0(42)
        , mdrpmb(7)
        , ix()  
        , dh1(58)
        , dh1(52)
        #y  
        , sy()
        , mdap(0)
        , alignrp(9)
        , tstemt_1(49)
        , mdrpmb(40)
        , tvtnc(15,[12,38])
        , mdrprg(26)
        , tstemw_2m(35)
        , mdrp0mrw(58)
        , vhead2(52,[64,70])
        , iy()
        , dh1(55)
        ),

    'uni0E59':    #THAI DIGIT NINE
        packline(""
        , tx2_0(74, 25,8, 42,47, 75, rstem=tstemtc_1)
        , add_ip(8,42,[28,5,3,1,34,55,39,50])
        , srp0(3)
        , mdrpmb(57)
        , f_ip([31])
        , srp0(1)
        , mdrpmb(0)
        , mdrp0mrw(19)
        , hhead2(13,[71,65])
        , ix()  
        , dh1(13)
        , dh1(19)
        #y  
        , sy()
        , mdap(1)
        , tvtnc(28,[25,8,3,59,31])
        , alignrp(34)
        , mdrprg(45)
        , tstemt_2(5)
        , shprp2(55)
        , mdrp0rg(50)
        , tstemtc_1(39)
        , srp0(1)
        , tvbc(22)
        , vhead1(16,[62,68])
        , iy()
        , dh1(12)
        , dh2(18)
        ),

    'uni0E5A':      #ANGKHANKHU
        packline(""
        , tx2_0(67, 14,64, 46,40, 68, fstem='')
        , srp0(46)
        , mdrp0mw(52)
        , mdrp0mrb(3)
        , mdapr(3)
        , tstemw_1(52)
        , shprp2(34)
        , add_ip(52,46,[37,49])
        , srp0(14)
        , mdrp0rg(20)
        , headstem_2(58)
        , ix()
        , dh1(17)
        , dh2(13)
        #y  
        , sy()
        , mdap(1)
        , alignrp(44)
        , tvtc2(17)
        , alignrp(31)
        , alignrp(37)
        , tstemw_2(6)
        , shprp2(49)
        , vhead2(13,[55,61])
        , mdrp0rg(11)
        , tstemt_1(26)
        , iy()
        , dh2(20)
        ),

    'uni0E5B':      #KHOMUT
        packline(""
        , tx2_0(97, 3,35, 56,72, 98, fstem='',rstem='')
        , mdrp0mrw(15)
        , hhead1(21,[95,91])
        , mdrp0rg(29)
        , mdrp0mb(9)
        , mdrp0mw(41)
        , mdrpmb(85)
        , add_ip(85,56,[43,46,48,50,79,81,84])
        , ix()
        , dh1(18)
        , dh12(23)
        #y  
        , sy()
        , mdapr(6)
        , tstemt_2(32)
        , mdapr(0)
        , tstemt_1m(38)
        , mdrp0mrw(12) 
        , tstemt_1m(26)
        , mdrp0rg(18)
        , vhead2(24,[89,93])
        , add_ip(0,6,[3,35,29,9,43,46,48,50,52,78,80,82,85,44,47,49,79,81,84])
        , mdapr(52)
        , tstemt_2(76)
        , iy()
        , dh1(15)
        , dh2(21)
        ),

    }



#++++++++++++++++++++++++++++++

#----- MODIFY pseudo_code_dict BY -----------
#----- SUBSTITUTE FUNCTION IN TEXT FORM -----
#----- TO REAL pseudo_code ------------------
from dttcmd import *

self_func = []
for i in dir():
    if callable(eval(i)): self_func.append(i)

for i in pseudo_code_dict.keys():
    p_list = pseudo_code_dict[i].split('\n')
    for j in range(len(p_list)):
        if '(' in p_list[j]:
            if p_list[j].split('(',1)[0] in self_func:
                l = [n for n in range(len(p_list[j])) if p_list[j][n] == ')']
                t = p_list[j][:l[-1]+1]
                p_list[j] = p_list[j].rep_listace(t, eval(t))
    pseudo_code_dict[i] = '\n'.join(p_list)
